// Widget made by Mathieu Thouvenin with Dashcode from Apple Inc.
// Please visit http://www.mathieuthouvenin.com/software for more informations
// Special thanks to Jon Brown for his version checker: http://www.widgetshow.com/?page_id=74

var currentVersion;
var currentStatus;

//
// Function: setup()
// Called at the setup of the widget.
// It checks to see if there is a preference for this widget and if so, applies 
// the preference to the widget. It also load the correct localized strings and
// the correct background (size big or small).
//

function setup()
{
	// always check to make sure that you are running in Dashboard
	if (window.widget)
	{
		// the preferences are retrieved:
		var size = widget.preferenceForKey("size");

		// if the retrieved preferences are not empty, they are restored
		if (size && size.length > 0)  
		{		
			if (size == "Big")
			{
				// set the correct background and position of the infobutton
				if (timeMachineStatus() == 1)
				{
					// Fading out the black and white icon
					var itemToFadeOut = document.getElementById("bigSize_bw");
					var fadeHandler = function(a, c, s, f){ itemToFadeOut.style.opacity = c; };
					new AppleAnimator(1000, 13, 1.0, 0.0, fadeHandler).start();
					
					// Fading in the color icon
					var itemToFadeIn = document.getElementById("bigSize");
					var fadeHandler = function(a, c, s, f){ itemToFadeIn.style.opacity = c; };
					new AppleAnimator(1000, 13, 0.0, 1.0, fadeHandler).start();
					
					document.getElementById('bigSize_bw').style.display = 'none';
					document.getElementById('bigSize').style.display = 'block';
					
					document.getElementById('off').style.display = 'block';
					document.getElementById('on').style.display = 'none';
					document.getElementById('off').style.bottom = '24px';
					document.getElementById('off').style.right = '100px';
				}
				else
				{	
					// Fading out the color icon
					var itemToFadeOut = document.getElementById("bigSize");
					var fadeHandler = function(a, c, s, f){ itemToFadeOut.style.opacity = c; };
					new AppleAnimator(1000, 13, 1.0, 0.0, fadeHandler).start();

					// Fading in the black and white icon
					var itemToFadeIn = document.getElementById("bigSize_bw");
					var fadeHandler = function(a, c, s, f){ itemToFadeIn.style.opacity = c; };
					new AppleAnimator(1000, 13, 0.0, 1.0, fadeHandler).start();

					document.getElementById('bigSize').style.display = 'none';
					document.getElementById('bigSize_bw').style.display = 'block';

					document.getElementById('off').style.display = 'none';
					document.getElementById('on').style.display = 'block';
					document.getElementById('on').style.bottom = '24px';
					document.getElementById('on').style.right = '100px';
				}
				document.getElementById('smallSize').style.display = 'none';
				document.getElementById('smallSize_bw').style.display = 'none';
				
				document.getElementById('info').style.bottom = '24px';
				document.getElementById('info').style.right = '22px';
				
				document.getElementById('pref').style.bottom = '100px';
				document.getElementById('pref').style.right = '22px';
				
				document.getElementById('backup').style.bottom = '100px';
				document.getElementById('backup').style.right = '100px';
																			
				// set the popup to reflect that.
				document.getElementById("sizePopup").selectedIndex = 0;
			}
			if (size == "Small")
			{
				// set the correct background and position of the infobutton
				if (timeMachineStatus() == 1)
				{	
					// Fading out the black and white icon
					var itemToFadeOut = document.getElementById("smallSize_bw");
					var fadeHandler = function(a, c, s, f){ itemToFadeOut.style.opacity = c; };
					new AppleAnimator(1000, 13, 1.0, 0.0, fadeHandler).start();
					
					// Fading in the color icon
					var itemToFadeIn = document.getElementById("smallSize");
					var fadeHandler = function(a, c, s, f){ itemToFadeIn.style.opacity = c; };
					new AppleAnimator(1000, 13, 0.0, 1.0, fadeHandler).start();
					
					document.getElementById('smallSize_bw').style.display = 'none';
					document.getElementById('smallSize').style.display = 'block';
					
					document.getElementById('off').style.display = 'block';
					document.getElementById('on').style.display = 'none';
					document.getElementById('off').style.bottom = '30px';
					document.getElementById('off').style.right = '90px';
				}
				else
				{					
					// Fading out the color icon
					var itemToFadeOut = document.getElementById("smallSize");
					var fadeHandler = function(a, c, s, f){ itemToFadeOut.style.opacity = c; };
					new AppleAnimator(1000, 13, 1.0, 0.0, fadeHandler).start();

					// Fading in the black and white icon
					var itemToFadeIn = document.getElementById("smallSize_bw");
					var fadeHandler = function(a, c, s, f){ itemToFadeIn.style.opacity = c; };
					new AppleAnimator(1000, 13, 0.0, 1.0, fadeHandler).start();
					
					document.getElementById('smallSize').style.display = 'none';
					document.getElementById('smallSize_bw').style.display = 'block';
					
					document.getElementById('off').style.display = 'none';
					document.getElementById('on').style.display = 'block';
					document.getElementById('on').style.bottom = '30px';
					document.getElementById('on').style.right = '90px';
				}
				document.getElementById('bigSize').style.display = 'none';
				document.getElementById('bigSize_bw').style.display = 'none';
				
				document.getElementById('info').style.bottom = '32px';
				document.getElementById('info').style.right = '30px';
				
				document.getElementById('pref').style.bottom = '92px';
				document.getElementById('pref').style.right = '30px';
				
				document.getElementById('backup').style.bottom = '91px';
				document.getElementById('backup').style.right = '91px';
				
				// set the popup to reflect that.
				document.getElementById("sizePopup").selectedIndex = 1;
			}
		}
		// load the correct localized strings
		document.getElementById('newVersionText').innerText = getLocalizedString('New Version');
		document.getElementById('bigText').innerText = getLocalizedString('Big');
		document.getElementById('smallText').innerText = getLocalizedString('Small');
		document.getElementById('widgetSizeText').innerText = getLocalizedString('Widget size:');
		
		// creation of the preferences button
		CreateSideButton("Time Machine Preferences", 'pref', document.getElementById('front'), 'preferences_button', showPreferences);

		// creation of the backup now button
		CreateSideButton("Backup Now", 'backup', document.getElementById('front'), 'backupnow_button', backupNow);
		
		// creation of the off button
		CreateSideButton("Turn Time Machine Off", 'off', document.getElementById('front'), 'off_button', turnOnOffTimeMachine);
		
		// creation of the on button
		CreateSideButton("Turn Time Machine On", 'on', document.getElementById('front'), 'on_button', turnOnOffTimeMachine);
	}
}

//
// Function: changeSize()
// Called whenever a menu item is chosen in the widget's preferences.
// It queries the  menu to find out which option was chosen, applies the change to 
// the widget, and saves the preference.
//
function changeSize(elem)
{	
	switch (elem.selectedIndex)
	{
		// if "Big" as been selected
		case 0:
			// set the correct background and position of the infobutton
			if (timeMachineStatus() == 1)
			{
				document.getElementById('bigSize').style.display = 'block';
				document.getElementById('bigSize_bw').style.display = 'none';
				
				document.getElementById('off').style.display = 'block';
				document.getElementById('on').style.display = 'none';
				document.getElementById('off').style.bottom = '24px';
				document.getElementById('off').style.right = '100px';
			}
			else
			{
				document.getElementById('bigSize_bw').style.display = 'block';
				document.getElementById('bigSize').style.display = 'none';
				
				document.getElementById('off').style.display = 'none';
				document.getElementById('on').style.display = 'block';
				document.getElementById('on').style.bottom = '24px';
				document.getElementById('on').style.right = '100px';
			}
			document.getElementById('smallSize').style.display = 'none';
			document.getElementById('smallSize_bw').style.display = 'none';
			
			document.getElementById('info').style.bottom = '24px';
			document.getElementById('info').style.right = '22px';
			document.getElementById('pref').style.bottom = '100px';
			document.getElementById('pref').style.right = '22px';
			document.getElementById('backup').style.bottom = '100px';
			document.getElementById('backup').style.right = '100px';
			if (window.widget)
			{
				// and save the new preference to disk
				widget.setPreferenceForKey("Big","size");
			}
			break;
			
		// if "Small" as been selected	
		case 1:
			// set the correct background and position of the infobutton
			if (timeMachineStatus() == 1)
			{
				document.getElementById('smallSize').style.display = 'block';
				document.getElementById('smallSize_bw').style.display = 'none';
				
				document.getElementById('off').style.display = 'block';
				document.getElementById('on').style.display = 'none';
				document.getElementById('off').style.bottom = '30px';
				document.getElementById('off').style.right = '90px';
			}
			else
			{
				document.getElementById('smallSize_bw').style.display = 'block';
				document.getElementById('smallSize').style.display = 'none';
				
				document.getElementById('off').style.display = 'none';
				document.getElementById('on').style.display = 'block';
				document.getElementById('on').style.bottom = '30px';
				document.getElementById('on').style.right = '90px';
			}
			document.getElementById('bigSize').style.display = 'none';
			document.getElementById('bigSize_bw').style.display = 'none';
			
			document.getElementById('info').style.bottom = '32px';
			document.getElementById('info').style.right = '30px';
			document.getElementById('pref').style.bottom = '92px';
			document.getElementById('pref').style.right = '30px';
			document.getElementById('backup').style.bottom = '91px';
			document.getElementById('backup').style.right = '91px';
			if (window.widget)
			{
				// and save the new preference to disk
				widget.setPreferenceForKey("Small","size");
			}
			break;
	}
} 

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
	// Check the status of Time Machine
	currentStatus = timeMachineStatus();
	
    setupParts();	
	setup();
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    widget.setPreferenceForKey(null, createInstancePreferenceKey("size"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
	// If the status is different, refresh the widget
	if (currentStatus != timeMachineStatus())
	{
		setup();
		currentStatus = timeMachineStatus();
	}
	
	// Check the version of the widget
	checkVersion();
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    instancePreferenceValue = widget.preferenceForKey(null, createInstancePreferenceKey("size"));
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}

//
// Function: launchTimeMachine(event)
// Called when the Time Machine icon is clicked from the front of the widget
//
// event: onClick event from the icon
//
function launchTimeMachine(event)
{
	widget.openApplication("com.apple.backup.launcher");
}

//
// Function: checkVersion()
// Called when the html document is loaded.
//
function checkVersion() 
{
    currentVersion = getKeyValue("Info.plist", "CFBundleVersion"); 
    checkForUpdate(); 
} 

//
// Function: checkForUpdate()
// Called when the html document is loaded (from checkVersion).
// Check if the version of the widget is the last one, from the server.
//
function checkForUpdate() 
{ 
    req = new XMLHttpRequest(); 
    req.onreadystatechange = compareVersion; 
    req.open("GET", "http://www.mathieuthouvenin.com/software/timemachinelauncher/version.php", true); 
    req.setRequestHeader("Cache-Control", "no-cache"); 
    req.send(null); 
} 

//
// Function: compareVersion()
// Called when the version is checked.
// Compare the version of the plist file to the version of the server.
//
function compareVersion() 
{ 
  if (req.readyState == 4) 
  { 
    if (req.status == 200) 
	{ 
        var serverVersion = req.responseText; 

		// display or not the "New Version" badge on the widget
        if ((currentVersion != serverVersion) && (serverVersion != null) && (serverVersion != "")) 
		{ 
            document.getElementById('updateAvailable').style.display='block'; 
        }
		else 
		{ 
            document.getElementById('updateAvailable').style.display='none'; 
        } 
    } 
  } 
} 

function getKeyValue(plist, key) 
{ 
   var xml_http = new XMLHttpRequest(); 
   xml_http.open("GET", plist, false); 
   xml_http.send(null); 
    
   var xml = xml_http.responseXML; 
   var key_value = null; 
   var nodes = xml.getElementsByTagName("dict")[0].childNodes; 

   for (var i=0; i < nodes.length; i++) 
   { 
      if (nodes[i].nodeType == 1 && nodes[i].tagName.toLowerCase() == "key" && nodes[i].firstChild.data == key) 
	  { 
         if (nodes[i+2].tagName.toLowerCase() != "array") 
		 { 
            key_value = nodes[i+2].firstChild.data; 
         } 
		 else 
		 { 
            key_value = new Array(); 
            var ar_nodes = nodes[i+2].childNodes; 
            for (var j=0; j < ar_nodes.length; j++) 
			{ 
               if (ar_nodes[j].nodeType == 1) key_value.push(ar_nodes[j].firstChild.data); 
            } 
         } 
         break; 
      } 
   } 
   return key_value; 
} 

// getLocalizedString() pulls a string out an array named localizedStrings.  
// Each language project directory in this widget contains a file named
// "localizedStrings.js", which, in turn, contains an array called localizedStrings.
// This method queries the array of the file of whichever language has highest 
// precidence, according to the International pane of System Preferences.

function getLocalizedString(key)
{
    try {
        var ret = localizedStrings[key];
        if (ret === undefined)
            ret = key;
        return ret;
    } catch (ex) {}
    return key;
}

//
// Function: aboutMe()
// Called when the info button at the back of the widget is clicked.
// Open the url of my website.
//
function aboutMe()
{
	widget.openURL("http://www.mathieuthouvenin.com/software/");
}

//
// Function: CreateSideButton()
// Called when in the setup() function in order to create a button
// that will be show on the side of the widget
//
function CreateSideButton(alt, flipperID, frontID, foregroundStyle, onclick)
{
	var flipElement = document.getElementById(flipperID);

	if (!flipElement.loaded) {
		flipElement.loaded = true;

		var onclick = onclick || null;
		try { onclick = eval(onclick); } catch (e) { onclick = null; }

		flipElement.object = new TMSideButton(alt, flipElement, frontID, foregroundStyle, onclick);
	
	}

	return flipElement.object;
}

//
// Function: showPreferences()
// Called when the user click on the preferences button and launch
// the System Preferences app in the Time Machine part.
//
function showPreferences()
{
	widget.openApplication("com.apple.SystemPreferences");
	widget.system("/usr/bin/osascript -e 'tell application \"System Preferences\" to set current pane to pane \"Time Machine\"'", null);
}

//
// Function: backupNow()
// Called when the user click on the Backup Now button. It forces
// Time Machine to do a backup.
//
function backupNow()
{
	var endHandler;
	var backupCommand = widget.system("/System/Library/CoreServices/backupd.bundle/Contents/Resources/backupd-helper", endHandler);
	alert("Command : "+backupCommand);
}

//
// Function: timeMachineStatus()
// Return 0 if Time Machine is OFF, and 1 if Time Machine is ON.
//
function timeMachineStatus()
{
	return widget.system("/usr/bin/osascript -e 'do shell script \"defaults read /Library/Preferences/com.apple.TimeMachine AutoBackup\"'", null).outputString;
}

//
// Function: turnOnOffTimeMachine()
// Called when the user click on the turn On/Off button. It forces
// Time Machine to turns ON or OFF.
//
function turnOnOffTimeMachine()
{
	if (timeMachineStatus() == 1)
	{
		widget.system("/usr/bin/osascript -e 'do shell script \"defaults write /Library/Preferences/com.apple.TimeMachine AutoBackup -boolean NO\"'", null);
	}
	else
	{
		widget.system("/usr/bin/osascript -e 'do shell script \"defaults write /Library/Preferences/com.apple.TimeMachine AutoBackup -boolean YES\"'", null);
	}
	
	setup();
}